using HslCommunication;
using Sln.Iot.PLC;
using Sln.Iot.Repository.service;
using Sln.Iot.Serilog;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Sln.Iot.Business
{
    public class RFID03Business
    {
        private Timer _timer;

        private readonly PLCConnect _plc = PLCConnect.Instance;

        private readonly SerilogHelper _log = SerilogHelper.Instance;

        public RFID03Business()
        {
            _timer = new Timer(TimerCallback, null, 0, 5000);
        }

        /// <summary>
        /// RFID03胶机1真空箱外数据处理流程
        /// </summary>
        /// <param name="state"></param>
        public void TimerCallback(object? state)
        {
            // 定时任务逻辑
            //读取信号
            OperateResult<short> signalRes = _plc.ReadInt16(_plc.DeltaInstance1, "D802");
            //成功验证
            if (signalRes.IsSuccess)
            {
                short signalValue = signalRes.Content;
                //如果有读取信号
                if (signalValue == 3001)
                {
                    //读取托盘码
                    OperateResult<byte[]> trayBytesResult = _plc.ReadBytes(_plc.DeltaInstance1, "D5020", 20);
                    //成功验证
                    if (trayBytesResult.IsSuccess)
                    {
                        //转换托盘码
                        string traycode = Encoding.ASCII.GetString(trayBytesResult.Content);

                        //sql更新
                        bool res = TrayBindingService.Instance.UpDateTime(DateTime.Now.ToString(), traycode, "1");
                        if (!res)
                        {
                            _log.Error("胶机1真空箱外数据库写入异常");
                        }

                        //写入完成信号
                        res = _plc.PlcWrite(_plc.DeltaInstance1, "D802", 3002, DataTypeEnum.UInt16).IsSuccess;
                        if (!res)
                        {
                            _log.Error("胶机1真空箱外写入完成信号异常");
                        }
                    }
                    //流程完成
                }
            }
            else
            {
                _log.Error("胶机1真空箱外PLC读取信号异常");
            }
        }
    }
}
